diff --git a/gcc/analyzer/supergraph.cc b/gcc/analyzer/supergraph.cc
index 8592db78395..a41b6a26ff7 100644
--- a/gcc/analyzer/supergraph.cc
+++ b/gcc/analyzer/supergraph.cc
@@ -547,144 +779,117 @@ supergraph::add_return_superedge (supernode *src, supernode *dest,
 void
 supernode::dump_dot (graphviz_out *gv, const dump_args_t &args) const
 {
-  gv->println ("subgraph cluster_node_%i {",
-	       m_index);
-  gv->indent ();
-
-  gv->println("style=\"solid\";");
-  gv->println("color=\"black\";");
-  gv->println("fillcolor=\"lightgrey\";");
-  gv->println("label=\"sn: %i (bb: %i)\";", m_index, m_bb->index);
-
   pretty_printer *pp = gv->get_pp ();
 
-  if (args.m_node_annotator)
-    args.m_node_annotator->add_node_annotations (gv, *this, false);
-
   gv->write_indent ();
   dump_dot_id (pp);
+
   pp_printf (pp,
-	     " [shape=none,margin=0,style=filled,fillcolor=%s,label=<",
-	     "lightgrey");
+	     " [shape=none,margin=0,style=filled,label=<");
   pp_string (pp, "<TABLE BORDER=\"0\">");
   pp_write_text_to_stream (pp);
 
-  bool had_row = false;
+  pp_printf (pp, "<TR><TD>sn: %i (bb: %i)",
+	     m_id, m_bb->index);
+  if (args.m_eg)
+    pp_printf (pp, "; scc: %i", args.m_eg->get_scc_id (*this));
+  pp_string (pp, "</TD></TR>");
+  pp_newline (pp);
 
-  /* Give any annotator the chance to add its own per-node TR elements. */
-  if (args.m_node_annotator)
-    if (args.m_node_annotator->add_node_annotations (gv, *this, true))
-      had_row = true;
-
-  if (m_returning_call)
+  if (m_preserve_p)
     {
-      gv->begin_trtd ();
-      pp_string (pp, "returning call: ");
-      gv->end_tdtr ();
-
-      gv->begin_tr ();
-      gv->begin_td ();
-      pp_gimple_stmt_1 (pp, m_returning_call, 0, (dump_flags_t)0);
-      pp_write_text_as_html_like_dot_to_stream (pp);
-      gv->end_td ();
-      /* Give any annotator the chance to add per-stmt TD elements to
-	 this row.  */
-      if (args.m_node_annotator)
-	args.m_node_annotator->add_stmt_annotations (gv, m_returning_call,
-						     true);
-      gv->end_tr ();
-
-      /* Give any annotator the chance to add per-stmt TR elements.  */
-      if (args.m_node_annotator)
-	args.m_node_annotator->add_stmt_annotations (gv, m_returning_call,
-						     false);
+      pp_string (pp, "<TR><TD>(preserve)</TD></TR>");
+      pp_newline (pp);
+    }
+  if (m_state_merger_node)
+    {
+      pp_string (pp, "<TR><TD BGCOLOR=\"#ec7a08\">"
+		 "<FONT COLOR=\"white\">STATE MERGER</FONT></TD></TR>");
       pp_newline (pp);
-
-      had_row = true;
     }
-
   if (entry_p ())
     {
       pp_string (pp, "<TR><TD>ENTRY</TD></TR>");
       pp_newline (pp);
-      had_row = true;
     }
-
-  if (return_p ())
+  else if (exit_p ())
     {
       pp_string (pp, "<TR><TD>EXIT</TD></TR>");
       pp_newline (pp);
-      had_row = true;
     }
 
-  /* Phi nodes.  */
-  for (gphi_iterator gpi = const_cast<supernode *> (this)->start_phis ();
-       !gsi_end_p (gpi); gsi_next (&gpi))
+  /* Source location.  */
+  /* Highlight nodes where we're missing source location information.
+     Ideally this all gets fixed up by supergraph::fixup_locations.  */
+  if (m_loc == UNKNOWN_LOCATION)
+    pp_string (pp, "<TR><TD>UNKNOWN_LOCATION</TD></TR>");
+  else if (get_pure_location (m_loc) == UNKNOWN_LOCATION)
     {
-      const gimple *stmt = gsi_stmt (gpi);
-      gv->begin_tr ();
-      gv->begin_td ();
-      pp_gimple_stmt_1 (pp, stmt, 0, (dump_flags_t)0);
-      pp_write_text_as_html_like_dot_to_stream (pp);
-      gv->end_td ();
-      /* Give any annotator the chance to add per-phi TD elements to
-	 this row.  */
-      if (args.m_node_annotator)
-	args.m_node_annotator->add_stmt_annotations (gv, stmt, true);
-      gv->end_tr ();
-
-      /* Give any annotator the chance to add per-phi TR elements.  */
-      if (args.m_node_annotator)
-	args.m_node_annotator->add_stmt_annotations (gv, stmt, false);
-
-      pp_newline (pp);
-      had_row = true;
+      pp_printf (pp, "<TR><TD>location: 0x%lx</TD></TR>", m_loc);
+      pp_string (pp, "<TR><TD>UNKNOWN_LOCATION</TD></TR>");
     }
-
-  /* Statements.  */
-  int i;
-  gimple *stmt;
-  FOR_EACH_VEC_ELT (m_stmts, i, stmt)
+  else
     {
-      gv->begin_tr ();
-      gv->begin_td ();
-      pp_gimple_stmt_1 (pp, stmt, 0, (dump_flags_t)0);
-      pp_write_text_as_html_like_dot_to_stream (pp);
-      gv->end_td ();
-      /* Give any annotator the chance to add per-stmt TD elements to
-	 this row.  */
-      if (args.m_node_annotator)
-	args.m_node_annotator->add_stmt_annotations (gv, stmt, true);
-      gv->end_tr ();
-
-      /* Give any annotator the chance to add per-stmt TR elements.  */
-      if (args.m_node_annotator)
-	args.m_node_annotator->add_stmt_annotations (gv, stmt, false);
-
-      pp_newline (pp);
-      had_row = true;
+      /* Show the source location, but skip it for the case where it's
+	 the same as all previous snodes (and there's a single in-edge).  */
+      bool show_location = true;
+      location_t prev_loc = UNKNOWN_LOCATION;
+      if (m_preds.length () == 1)
+	{
+	  prev_loc = m_preds[0]->m_src->m_loc;
+	  if (prev_loc == m_loc)
+	    show_location = false;
+	}
+      if (show_location)
+	{
+	  pp_printf (pp, "<TR><TD>location: 0x%lx</TD></TR>", m_loc);
+
+	  /* Print changes to the expanded location (or all of it if
+	     we have multiple in-edges).  */
+	  auto prev_exploc = expand_location (prev_loc);
+	  auto exploc = expand_location (m_loc);
+
+	  if ((exploc.file != prev_exploc.file)
+	      && exploc.file)
+	    pp_printf (pp, "<TR><TD>%s:%i:</TD></TR>",
+		       exploc.file, exploc.line);
+	  if (exploc.line != prev_exploc.line)
+	    if (const diagnostics::char_span line
+		= global_dc->get_file_cache ().get_source_line (exploc.file,
+								exploc.line))
+	      {
+		/* Print the source line.  */
+		pp_string (pp, "<TR><TD>");
+		pp_string (pp, "<TABLE BORDER=\"0\"><TR>");
+
+		// Line number:
+		pp_printf (pp, ("<TD ALIGN=\"RIGHT\" BGCOLOR=\"#0088ce\">"
+				"<FONT COLOR=\"white\"> %i</FONT></TD>"),
+			   exploc.line);
+
+		// Line contents:
+		pp_string (pp, "<TD ALIGN=\"LEFT\" BGCOLOR=\"white\">");
+		pp_flush (pp);
+		for (size_t i = 0; i < line.length (); ++i)
+		  pp_character (pp, line[i]);
+		pp_write_text_as_html_like_dot_to_stream (pp);
+		pp_string (pp, "</TD>");
+
+		pp_string (pp, "</TR></TABLE>");
+		pp_string (pp, "</TD></TR>");
+	      }
+	}
     }
 
-  /* Give any annotator the chance to add additional per-node TR elements
-     to the end of the TABLE. */
+  pp_flush (pp);
+
   if (args.m_node_annotator)
-    if (args.m_node_annotator->add_after_node_annotations (gv, *this))
-      had_row = true;
+    args.m_node_annotator->add_node_annotations (gv, *this);
 
-  /* Graphviz requires a TABLE element to have at least one TR
-     (and each TR to have at least one TD).  */
-  if (!had_row)
-    {
-      pp_string (pp, "<TR><TD>(empty)</TD></TR>");
-      pp_newline (pp);
-    }
+  pp_printf (pp, "<TR><TD>m_stmt_loc: 0x%lx</TD></TR>", m_stmt_loc);
 
   pp_string (pp, "</TABLE>>];\n\n");
   pp_flush (pp);
-
-  /* Terminate "subgraph" */
-  gv->outdent ();
-  gv->println ("}");
 }
 
 /* Write an ID for this node to PP, for use in .dot output.  */
@@ -692,184 +897,33 @@ supernode::dump_dot (graphviz_out *gv, const dump_args_t &args) const
 void
 supernode::dump_dot_id (pretty_printer *pp) const
 {
-  pp_printf (pp, "node_%i", m_index);
+  pp_printf (pp, "node_%i", m_id);
 }
 
 /* Return a new json::object of the form
-   {"idx": int,
+   {"id": int,
     "fun": optional str
-    "bb_idx": int,
-    "returning_call": optional str,
-    "phis": [str],
-    "stmts" : [str]}.  */
+    "bb_idx": int}.  */
 
 std::unique_ptr<json::object>
 supernode::to_json () const
 {
   auto snode_obj = std::make_unique<json::object> ();
 
-  snode_obj->set_integer ("idx", m_index);
+  snode_obj->set_integer ("id", m_id);
   snode_obj->set_integer ("bb_idx", m_bb->index);
   if (function *fun = get_function ())
     snode_obj->set_string ("fun", function_name (fun));
 
-  if (m_returning_call)
-    {
-      pretty_printer pp;
-      pp_format_decoder (&pp) = default_tree_printer;
-      pp_gimple_stmt_1 (&pp, m_returning_call, 0, (dump_flags_t)0);
-      snode_obj->set_string ("returning_call", pp_formatted_text (&pp));
-    }
-
-  /* Phi nodes.  */
-  {
-    auto phi_arr = std::make_unique<json::array> ();
-    for (gphi_iterator gpi = const_cast<supernode *> (this)->start_phis ();
-	 !gsi_end_p (gpi); gsi_next (&gpi))
-      {
-	const gimple *stmt = gsi_stmt (gpi);
-	pretty_printer pp;
-	pp_format_decoder (&pp) = default_tree_printer;
-	pp_gimple_stmt_1 (&pp, stmt, 0, (dump_flags_t)0);
-	phi_arr->append_string (pp_formatted_text (&pp));
-      }
-    snode_obj->set ("phis", std::move (phi_arr));
-  }
-
-  /* Statements.  */
-  {
-    auto stmt_arr = std::make_unique<json::array> ();
-    int i;
-    gimple *stmt;
-    FOR_EACH_VEC_ELT (m_stmts, i, stmt)
-      {
-	pretty_printer pp;
-	pp_format_decoder (&pp) = default_tree_printer;
-	pp_gimple_stmt_1 (&pp, stmt, 0, (dump_flags_t)0);
-	stmt_arr->append_string (pp_formatted_text (&pp));
-      }
-    snode_obj->set ("stmts", std::move (stmt_arr));
-  }
-
   return snode_obj;
 }
 
-/* Get a location_t for the start of this supernode.  */
-
-location_t
-supernode::get_start_location () const
-{
-  if (m_returning_call
-      && get_pure_location (m_returning_call->location) != UNKNOWN_LOCATION)
-    return m_returning_call->location;
-
-  int i;
-  gimple *stmt;
-  FOR_EACH_VEC_ELT (m_stmts, i, stmt)
-    if (get_pure_location (stmt->location) != UNKNOWN_LOCATION)
-      return stmt->location;
-
-  if (entry_p ())
-    {
-      // TWEAK: show the decl instead; this leads to more readable output:
-      return DECL_SOURCE_LOCATION (m_fun->decl);
-
-      return m_fun->function_start_locus;
-    }
-  if (return_p ())
-    return m_fun->function_end_locus;
-
-  /* We have no locations for stmts.  If we have a single out-edge that's
-     a CFG edge, the goto_locus of that edge is a better location for this
-     than UNKNOWN_LOCATION.  */
-  if (m_succs.length () == 1)
-    if (const cfg_superedge *cfg_sedge = m_succs[0]->dyn_cast_cfg_superedge ())
-      return cfg_sedge->get_goto_locus ();
-
-  return UNKNOWN_LOCATION;
-}
-
-/* Get a location_t for the end of this supernode.  */
-
-location_t
-supernode::get_end_location () const
-{
-  int i;
-  gimple *stmt;
-  FOR_EACH_VEC_ELT_REVERSE (m_stmts, i, stmt)
-    if (get_pure_location (stmt->location) != UNKNOWN_LOCATION)
-      return stmt->location;
-
-  if (m_returning_call
-      && get_pure_location (m_returning_call->location) != UNKNOWN_LOCATION)
-    return m_returning_call->location;
-
-  if (entry_p ())
-    return m_fun->function_start_locus;
-  if (return_p ())
-    return m_fun->function_end_locus;
-
-  /* If we have a single out-edge that's a CFG edge, use the goto_locus of
-     that edge.  */
-  if (m_succs.length () == 1)
-    if (const cfg_superedge *cfg_sedge = m_succs[0]->dyn_cast_cfg_superedge ())
-      return cfg_sedge->get_goto_locus ();
-
-  return UNKNOWN_LOCATION;
-}
-
-/* Given STMT within this supernode, return its index within m_stmts.  */
-
-unsigned int
-supernode::get_stmt_index (const gimple *stmt) const
-{
-  unsigned i;
-  gimple *iter_stmt;
-  FOR_EACH_VEC_ELT (m_stmts, i, iter_stmt)
-    if (iter_stmt == stmt)
-      return i;
-  gcc_unreachable ();
-}
-
-/* Get any label_decl for this supernode, or NULL_TREE if there isn't one.  */
-
-tree
-supernode::get_label () const
-{
-  if (m_stmts.length () == 0)
-    return NULL_TREE;
-  const glabel *label_stmt = dyn_cast<const glabel *> (m_stmts[0]);
-  if (!label_stmt)
-    return NULL_TREE;
-  return gimple_label_label (label_stmt);
-}
-
-/* Get a string for PK.  */
-
-static const char *
-edge_kind_to_string (enum edge_kind kind)
-{
-  switch (kind)
-    {
-    default:
-      gcc_unreachable ();
-    case SUPEREDGE_CFG_EDGE:
-      return "SUPEREDGE_CFG_EDGE";
-    case SUPEREDGE_CALL:
-      return "SUPEREDGE_CALL";
-    case SUPEREDGE_RETURN:
-      return "SUPEREDGE_RETURN";
-    case SUPEREDGE_INTRAPROCEDURAL_CALL:
-      return "SUPEREDGE_INTRAPROCEDURAL_CALL";
-    }
-};
-
 /* Dump this superedge to PP.  */
 
 void
 superedge::dump (pretty_printer *pp) const
 {
-  pp_printf (pp, "edge: SN: %i -> SN: %i", m_src->m_index, m_dest->m_index);
+  pp_printf (pp, "edge: SN: %i -> SN: %i", m_src->m_id, m_dest->m_id);
   label_text desc (get_description (false));
   if (strlen (desc.get ()) > 0)
     {
@@ -899,23 +953,6 @@ superedge::dump_dot (graphviz_out *gv, const dump_args_t &) const
   int weight = 10;
   const char *constraint = "true";
 
-  switch (m_kind)
-    {
-    default:
-      gcc_unreachable ();
-    case SUPEREDGE_CFG_EDGE:
-      break;
-    case SUPEREDGE_CALL:
-      color = "red";
-      break;
-    case SUPEREDGE_RETURN:
-      color = "green";
-      break;
-    case SUPEREDGE_INTRAPROCEDURAL_CALL:
-      style = "\"dotted\"";
-      break;
-    }
-
   /* Adapted from graph.cc:draw_cfg_node_succ_edges.  */
   if (::edge cfg_edge = get_any_cfg_edge ())
     {
@@ -950,60 +987,57 @@ superedge::dump_dot (graphviz_out *gv, const dump_args_t &) const
   m_dest->dump_dot_id (pp);
   pp_printf (pp,
 	     (" [style=%s, color=%s, weight=%d, constraint=%s,"
-	      " ltail=\"cluster_node_%i\", lhead=\"cluster_node_%i\""
+	      //" ltail=\"cluster_node_%i\", lhead=\"cluster_node_%i\""
 	      " headlabel=\""),
-	     style, color, weight, constraint,
-	     m_src->m_index, m_dest->m_index);
+	     style, color, weight, constraint
+	     /*, m_src->m_id, m_dest->m_id*/);
+  pp_flush (pp);
 
   dump_label_to_pp (pp, false);
+  pp_write_text_as_dot_label_to_stream (pp, false);
 
   pp_printf (pp, "\"];\n");
 }
 
 /* Return a new json::object of the form
    {"kind"   : str,
-    "src_idx": int, the index of the source supernode,
-    "dst_idx": int, the index of the destination supernode,
+    "src_id": int, the index of the source supernode,
+    "dst_id": int, the index of the destination supernode,
     "desc"   : str.  */
 
 std::unique_ptr<json::object>
 superedge::to_json () const
 {
   auto sedge_obj = std::make_unique<json::object> ();
-  sedge_obj->set_string ("kind", edge_kind_to_string (m_kind));
-  sedge_obj->set_integer ("src_idx", m_src->m_index);
-  sedge_obj->set_integer ("dst_idx", m_dest->m_index);
-
+  sedge_obj->set_integer ("src_id", m_src->m_id);
+  sedge_obj->set_integer ("dst_id", m_dest->m_id);
+  // TODO: m_op
+  // TODO: m_cfg_edge;
+#if 0
   {
     pretty_printer pp;
     pp_format_decoder (&pp) = default_tree_printer;
     dump_label_to_pp (&pp, false);
     sedge_obj->set_string ("desc", pp_formatted_text (&pp));
   }
+#endif
 
   return sedge_obj;
 }
 
-/* If this is an intraprocedural superedge, return the associated
-   CFG edge.  Otherwise, return nullptr.  */
+/* Return true iff this edge needs to be preserved during simplification.  */
 
-::edge
-superedge::get_any_cfg_edge () const
-{
-  if (const cfg_superedge *sub = dyn_cast_cfg_superedge ())
-    return sub->get_cfg_edge ();
-  return nullptr;
-}
-
-/* If this is an interprocedural superedge, return the associated
-   cgraph_edge *.  Otherwise, return nullptr.  */
-
-cgraph_edge *
-superedge::get_any_callgraph_edge () const
+bool
+superedge::preserve_p () const
 {
-  if (const callgraph_superedge *sub = dyn_cast_callgraph_superedge ())
-    return sub->m_cedge;
-  return nullptr;
+  if (m_cfg_edge)
+    if (m_cfg_edge->flags & (EDGE_EH | EDGE_DFS_BACK))
+      {
+	/* We use EDGE_EH in get_eh_outedge, and EDGE_DFS_BACK
+	   for detecting infinite loops.  */
+	return true;
+      }
+  return false;
 }
 
 /* Build a description of this superedge (e.g. "true" for the true
@@ -1021,563 +1055,48 @@ superedge::get_description (bool user_facing) const
   return label_text::take (xstrdup (pp_formatted_text (&pp)));
 }
 
-/* Implementation of superedge::dump_label_to_pp for non-switch CFG
-   superedges.
-
-   For true/false edges, print "true" or "false" to PP.
-
-   If USER_FACING is false, also print flags on the underlying CFG edge to
-   PP.  */
-
 void
-cfg_superedge::dump_label_to_pp (pretty_printer *pp,
-				 bool user_facing) const
+superedge::dump_label_to_pp (pretty_printer *pp, bool user_facing) const
 {
-  if (true_value_p ())
-    pp_printf (pp, "true");
-  else if (false_value_p ())
-    pp_printf (pp, "false");
+  if (get_op ())
+    get_op ()->print_as_edge_label (pp, user_facing);
+  else
+    pp_printf (pp, "no-op");
 
   if (user_facing)
     return;
 
-  /* Express edge flags as a string with " | " separator.
-     e.g. " (flags FALLTHRU | DFS_BACK)".  */
-  if (get_flags ())
+  if (::edge cfg_edge = get_any_cfg_edge ())
     {
-      pp_string (pp, " (flags ");
-      bool seen_flag = false;
+      if (cfg_edge->flags)
+	{
+	  pp_string (pp, " (flags ");
+	  bool seen_flag = false;
 #define DEF_EDGE_FLAG(NAME,IDX)			\
-  do {						\
-    if (get_flags () & EDGE_##NAME)			\
-      {						\
-	if (seen_flag)				\
-	  pp_string (pp, " | ");			\
-	pp_printf (pp, "%s", (#NAME));		\
-	seen_flag = true;			\
-      }						\
-  } while (0);
+	  do {						\
+	    if (cfg_edge->flags & EDGE_##NAME)		\
+	      {						\
+		if (seen_flag)					\
+		  pp_string (pp, " | ");			\
+		pp_printf (pp, "%s", (#NAME));			\
+		seen_flag = true;				\
+	      }						\
+	  } while (0);
 #include "cfg-flags.def"
 #undef DEF_EDGE_FLAG
-      pp_string (pp, ")");
-    }
-
-  if (m_cfg_edge->goto_locus > BUILTINS_LOCATION)
-    pp_string (pp, " (has goto_locus)");
-
-  /* Otherwise, no label.  */
-}
-
-/* Get the index number for this edge for use in phi stmts
-   in its destination.  */
-
-size_t
-cfg_superedge::get_phi_arg_idx () const
-{
-  return m_cfg_edge->dest_idx;
-}
-
-/* Get the phi argument for PHI for this CFG edge.  */
-
-tree
-cfg_superedge::get_phi_arg (const gphi *phi) const
-{
-  size_t index = get_phi_arg_idx ();
-  return gimple_phi_arg_def (phi, index);
-}
-
-/* class switch_cfg_superedge : public cfg_superedge.  */
-
-switch_cfg_superedge::switch_cfg_superedge (supernode *src,
-					    supernode *dst,
-					    ::edge e)
-: cfg_superedge (src, dst, e)
-{
-  /* Populate m_case_labels with all cases which go to DST.  */
-  const gswitch *gswitch = get_switch_stmt ();
-  for (unsigned i = 0; i < gimple_switch_num_labels (gswitch); i++)
-    {
-      tree case_ = gimple_switch_label (gswitch, i);
-      basic_block bb = label_to_block (src->get_function (),
-				       CASE_LABEL (case_));
-      if (bb == dst->m_bb)
-	m_case_labels.safe_push (case_);
-    }
-}
-
-/* Implementation of superedge::dump_label_to_pp for CFG superedges for
-   "switch" statements.
-
-   Print "case VAL:", "case LOWER ... UPPER:", or "default:" to PP.  */
-
-void
-switch_cfg_superedge::dump_label_to_pp (pretty_printer *pp,
-					bool user_facing ATTRIBUTE_UNUSED) const
-{
-  if (user_facing)
-    {
-      for (unsigned i = 0; i < m_case_labels.length (); ++i)
-	{
-	  if (i > 0)
-	    pp_string (pp, ", ");
-	  tree case_label = m_case_labels[i];
-	  gcc_assert (TREE_CODE (case_label) == CASE_LABEL_EXPR);
-	  tree lower_bound = CASE_LOW (case_label);
-	  tree upper_bound = CASE_HIGH (case_label);
-	  if (lower_bound)
-	    {
-	      pp_printf (pp, "case ");
-	      dump_generic_node (pp, lower_bound, 0, (dump_flags_t)0, false);
-	      if (upper_bound)
-		{
-		  pp_printf (pp, " ... ");
-		  dump_generic_node (pp, upper_bound, 0, (dump_flags_t)0,
-				     false);
-		}
-	      pp_printf (pp, ":");
-	    }
-	  else
-	    pp_printf (pp, "default:");
-	}
-    }
-  else
-    {
-      pp_character (pp, '{');
-      for (unsigned i = 0; i < m_case_labels.length (); ++i)
-	{
-	  if (i > 0)
-	    pp_string (pp, ", ");
-	  tree case_label = m_case_labels[i];
-	  gcc_assert (TREE_CODE (case_label) == CASE_LABEL_EXPR);
-	  tree lower_bound = CASE_LOW (case_label);
-	  tree upper_bound = CASE_HIGH (case_label);
-	  if (lower_bound)
-	    {
-	      if (upper_bound)
-		{
-		  pp_character (pp, '[');
-		  dump_generic_node (pp, lower_bound, 0, (dump_flags_t)0,
-				     false);
-		  pp_string (pp, ", ");
-		  dump_generic_node (pp, upper_bound, 0, (dump_flags_t)0,
-				     false);
-		  pp_character (pp, ']');
-		}
-	      else
-		dump_generic_node (pp, lower_bound, 0, (dump_flags_t)0, false);
-	    }
-	  else
-	    pp_printf (pp, "default");
-	}
-      pp_character (pp, '}');
-      if (implicitly_created_default_p ())
-	{
-	  pp_string (pp, " IMPLICITLY CREATED");
-	}
-    }
-}
-
-/* Return true iff this edge is purely for an implicitly-created "default".  */
-
-bool
-switch_cfg_superedge::implicitly_created_default_p () const
-{
-  if (m_case_labels.length () != 1)
-    return false;
-
-  tree case_label = m_case_labels[0];
-  gcc_assert (TREE_CODE (case_label) == CASE_LABEL_EXPR);
-  if (CASE_LOW (case_label))
-    return false;
-
-  /* We have a single "default" case.
-     Assume that it was implicitly created if it has UNKNOWN_LOCATION.  */
-  return EXPR_LOCATION (case_label) == UNKNOWN_LOCATION;
-}
-
-/* class eh_dispatch_cfg_superedge : public cfg_superedge.  */
-
-/* Given an ERT_TRY region, get the eh_catch corresponding to
-   the label of DST_SNODE, if any.  */
-
-static eh_catch
-get_catch (eh_region eh_reg, supernode *dst_snode)
-{
-  gcc_assert (eh_reg->type == ERT_TRY);
-
-  tree dst_snode_label = dst_snode->get_label ();
-  if (!dst_snode_label)
-    return nullptr;
-
-  for (eh_catch iter = eh_reg->u.eh_try.first_catch;
-       iter;
-       iter = iter->next_catch)
-    if (iter->label == dst_snode_label)
-      return iter;
-
-  return nullptr;
-}
-
-std::unique_ptr<eh_dispatch_cfg_superedge>
-eh_dispatch_cfg_superedge::make (supernode *src_snode,
-				 supernode *dst_snode,
-				 ::edge e,
-				 const geh_dispatch *eh_dispatch_stmt)
-{
-  const eh_status *eh = src_snode->get_function ()->eh;
-  gcc_assert (eh);
-  int region_idx = gimple_eh_dispatch_region (eh_dispatch_stmt);
-  gcc_assert (region_idx > 0);
-  gcc_assert ((*eh->region_array)[region_idx]);
-  eh_region eh_reg = (*eh->region_array)[region_idx];
-  gcc_assert (eh_reg);
-  switch (eh_reg->type)
-    {
-    default:
-      gcc_unreachable ();
-    case ERT_CLEANUP:
-      // TODO
-      gcc_unreachable ();
-      break;
-    case ERT_TRY:
-      {
-	eh_catch ehc = get_catch (eh_reg, dst_snode);
-	return std::make_unique<eh_dispatch_try_cfg_superedge>
-	  (src_snode, dst_snode,
-	   e, eh_dispatch_stmt,
-	   eh_reg, ehc);
-      }
-      break;
-    case ERT_ALLOWED_EXCEPTIONS:
-      return std::make_unique<eh_dispatch_allowed_cfg_superedge>
-	(src_snode, dst_snode,
-	 e, eh_dispatch_stmt,
-	 eh_reg);
-      break;
-    case ERT_MUST_NOT_THROW:
-      // TODO
-      gcc_unreachable ();
-      break;
-    }
-}
-
-eh_dispatch_cfg_superedge::
-eh_dispatch_cfg_superedge (supernode *src,
-			   supernode *dst,
-			   ::edge e,
-			   const geh_dispatch *eh_dispatch_stmt,
-			   eh_region eh_reg)
-: cfg_superedge (src, dst, e),
-  m_eh_dispatch_stmt (eh_dispatch_stmt),
-  m_eh_region (eh_reg)
-{
-  gcc_assert (m_eh_region);
-}
-
-const eh_status &
-eh_dispatch_cfg_superedge::get_eh_status () const
-{
-  const eh_status *eh = m_src->get_function ()->eh;
-  gcc_assert (eh);
-  return *eh;
-}
-
-// class eh_dispatch_try_cfg_superedge : public eh_dispatch_cfg_superedge
-
-/* Implementation of superedge::dump_label_to_pp for CFG superedges for
-   "eh_dispatch" statements for ERT_TRY regions.  */
-
-void
-eh_dispatch_try_cfg_superedge::dump_label_to_pp (pretty_printer *pp,
-						 bool user_facing) const
-{
-  if (!user_facing)
-    pp_string (pp, "ERT_TRY: ");
-  if (m_eh_catch)
-    {
-      bool first = true;
-      for (tree iter = m_eh_catch->type_list; iter; iter = TREE_CHAIN (iter))
-	{
-	  if (!first)
-	    pp_string (pp, ", ");
-	  pp_printf (pp, "on catch %qT", TREE_VALUE (iter));
-	  first = false;
+	  pp_string (pp, ")");
 	}
+      if (cfg_edge->goto_locus > BUILTINS_LOCATION)
+	pp_printf (pp, " (has goto_locus: 0x%lx)", cfg_edge->goto_locus);
     }
-  else
-    pp_string (pp, "on uncaught exception");
 }
 
 bool
-eh_dispatch_try_cfg_superedge::
-apply_constraints (region_model *model,
-		   region_model_context *ctxt,
-		   tree exception_type,
-		   std::unique_ptr<rejected_constraint> *out) const
-{
-  return model->apply_constraints_for_eh_dispatch_try
-    (*this, ctxt, exception_type, out);
-}
-
-// class eh_dispatch_allowed_cfg_superedge : public eh_dispatch_cfg_superedge
-
-eh_dispatch_allowed_cfg_superedge::
-eh_dispatch_allowed_cfg_superedge (supernode *src, supernode *dst, ::edge e,
-				   const geh_dispatch *eh_dispatch_stmt,
-				   eh_region eh_reg)
-: eh_dispatch_cfg_superedge (src, dst, e, eh_dispatch_stmt, eh_reg)
-{
-  gcc_assert (eh_reg->type == ERT_ALLOWED_EXCEPTIONS);
-
-  /* We expect two sibling out-edges at an eh_dispatch from such a region:
-
-     - one to a bb without a gimple label, with a resx,
-     for exceptions of expected types
-
-     - one to a bb with a gimple label, with a call to __cxa_unexpected,
-     for exceptions of unexpected types.
-
-     Set m_kind for this edge accordingly.  */
-  gcc_assert (e->src->succs->length () == 2);
-  tree label_for_unexpected_exceptions = eh_reg->u.allowed.label;
-  tree label_for_dest_enode = dst->get_label ();
-  if (label_for_dest_enode == label_for_unexpected_exceptions)
-    m_kind = eh_kind::unexpected;
-  else
-    {
-      gcc_assert (label_for_dest_enode == nullptr);
-      m_kind = eh_kind::expected;
-    }
-}
-
-void
-eh_dispatch_allowed_cfg_superedge::dump_label_to_pp (pretty_printer *pp,
-						     bool user_facing) const
+superedge::supports_bulk_merge_p () const
 {
-  if (!user_facing)
-    {
-      switch (m_kind)
-	{
-	default:
-	  gcc_unreachable ();
-	case eh_dispatch_allowed_cfg_superedge::eh_kind::expected:
-	  pp_string (pp, "expected: ");
-	  break;
-	case eh_dispatch_allowed_cfg_superedge::eh_kind::unexpected:
-	  pp_string (pp, "unexpected: ");
-	  break;
-	}
-      pp_string (pp, "ERT_ALLOWED_EXCEPTIONS: ");
-      eh_region eh_reg = get_eh_region ();
-      bool first = true;
-      for (tree iter = eh_reg->u.allowed.type_list; iter;
-	   iter = TREE_CHAIN (iter))
-	{
-	  if (!first)
-	    pp_string (pp, ", ");
-	  pp_printf (pp, "%qT", TREE_VALUE (iter));
-	  first = false;
-	}
-    }
-}
-
-bool
-eh_dispatch_allowed_cfg_superedge::
-apply_constraints (region_model *model,
-		   region_model_context *ctxt,
-		   tree exception_type,
-		   std::unique_ptr<rejected_constraint> *out) const
-{
-  return model->apply_constraints_for_eh_dispatch_allowed
-    (*this, ctxt, exception_type, out);
-}
-
-/* Implementation of superedge::dump_label_to_pp for interprocedural
-   superedges.  */
-
-void
-callgraph_superedge::dump_label_to_pp (pretty_printer *pp,
-				       bool user_facing ATTRIBUTE_UNUSED) const
-{
-  switch (m_kind)
-    {
-    default:
-    case SUPEREDGE_CFG_EDGE:
-      gcc_unreachable ();
-
-    case SUPEREDGE_CALL:
-      pp_printf (pp, "call");
-      break;
-
-    case SUPEREDGE_RETURN:
-      pp_printf (pp, "return");
-      break;
-
-    case SUPEREDGE_INTRAPROCEDURAL_CALL:
-      pp_printf (pp, "intraproc link");
-      break;
-    }
-}
-
-/* Get the function that was called at this interprocedural call/return
-   edge.  */
-
-function *
-callgraph_superedge::get_callee_function () const
-{
-  return get_ultimate_function_for_cgraph_edge (m_cedge);
-}
-
-/* Get the calling function at this interprocedural call/return edge.  */
-
-function *
-callgraph_superedge::get_caller_function () const
-{
-  return m_cedge->caller->get_fun ();
-}
-
-/* Get the fndecl that was called at this interprocedural call/return
-   edge.  */
-
-tree
-callgraph_superedge::get_callee_decl () const
-{
-  return get_callee_function ()->decl;
-}
-
-/* Get the gcall * of this interprocedural call/return edge.  */
-
-const gcall &
-callgraph_superedge::get_call_stmt () const
-{
-  if (m_cedge)
-    return *m_cedge->call_stmt;
-
-  return *m_src->get_final_call ();
-}
-
-/* Get the calling fndecl at this interprocedural call/return edge.  */
-
-tree
-callgraph_superedge::get_caller_decl () const
-{
-  return get_caller_function ()->decl;
-}
-
-/* Given PARM_TO_FIND, a PARM_DECL, identify its index (writing it
-   to *OUT if OUT is non-NULL), and return the corresponding argument
-   at the callsite.  */
-
-tree
-callgraph_superedge::get_arg_for_parm (tree parm_to_find,
-				       callsite_expr *out) const
-{
-  gcc_assert  (TREE_CODE (parm_to_find) == PARM_DECL);
-
-  tree callee = get_callee_decl ();
-  const gcall &call_stmt = get_call_stmt ();
-
-  unsigned i = 0;
-  for (tree iter_parm = DECL_ARGUMENTS (callee); iter_parm;
-       iter_parm = DECL_CHAIN (iter_parm), ++i)
-    {
-      if (i >= gimple_call_num_args (&call_stmt))
-	return NULL_TREE;
-      if (iter_parm == parm_to_find)
-	{
-	  if (out)
-	    *out = callsite_expr::from_zero_based_param (i);
-	  return gimple_call_arg (&call_stmt, i);
-	}
-    }
-
-  /* Not found.  */
-  return NULL_TREE;
-}
-
-/* Look for a use of ARG_TO_FIND as an argument at this callsite.
-   If found, return the default SSA def of the corresponding parm within
-   the callee, and if OUT is non-NULL, write the index to *OUT.
-   Only the first match is handled.  */
-
-tree
-callgraph_superedge::get_parm_for_arg (tree arg_to_find,
-				       callsite_expr *out) const
-{
-  tree callee = get_callee_decl ();
-  const gcall &call_stmt = get_call_stmt ();
-
-  unsigned i = 0;
-  for (tree iter_parm = DECL_ARGUMENTS (callee); iter_parm;
-       iter_parm = DECL_CHAIN (iter_parm), ++i)
-    {
-      if (i >= gimple_call_num_args (&call_stmt))
-	return NULL_TREE;
-      tree param = gimple_call_arg (&call_stmt, i);
-      if (arg_to_find == param)
-	{
-	  if (out)
-	    *out = callsite_expr::from_zero_based_param (i);
-	  return ssa_default_def (get_callee_function (), iter_parm);
-	}
-    }
-
-  /* Not found.  */
-  return NULL_TREE;
-}
-
-/* Map caller_expr back to an expr within the callee, or return NULL_TREE.
-   If non-NULL is returned, populate OUT.  */
-
-tree
-callgraph_superedge::map_expr_from_caller_to_callee (tree caller_expr,
-						     callsite_expr *out) const
-{
-  /* Is it an argument (actual param)?  If so, convert to
-     parameter (formal param).  */
-  tree parm = get_parm_for_arg (caller_expr, out);
-  if (parm)
-    return parm;
-  /* Otherwise try return value.  */
-  if (caller_expr == gimple_call_lhs (&get_call_stmt ()))
-    {
-      if (out)
-	*out = callsite_expr::from_return_value ();
-      return DECL_RESULT (get_callee_decl ());
-    }
-
-  return NULL_TREE;
-}
-
-/* Map callee_expr back to an expr within the caller, or return NULL_TREE.
-   If non-NULL is returned, populate OUT.  */
-
-tree
-callgraph_superedge::map_expr_from_callee_to_caller (tree callee_expr,
-						     callsite_expr *out) const
-{
-  if (callee_expr == NULL_TREE)
-    return NULL_TREE;
-
-  /* If it's a parameter (formal param), get the argument (actual param).  */
-  if (TREE_CODE (callee_expr) == PARM_DECL)
-    return get_arg_for_parm (callee_expr, out);
-
-  /* Similar for the default SSA name of the PARM_DECL.  */
-  if (TREE_CODE (callee_expr) == SSA_NAME
-      && SSA_NAME_IS_DEFAULT_DEF (callee_expr)
-      && TREE_CODE (SSA_NAME_VAR (callee_expr)) == PARM_DECL)
-    return get_arg_for_parm (SSA_NAME_VAR (callee_expr), out);
-
-  /* Otherwise try return value.  */
-  if (callee_expr == DECL_RESULT (get_callee_decl ()))
-    {
-      if (out)
-	*out = callsite_expr::from_return_value ();
-      return gimple_call_lhs (&get_call_stmt ());
-    }
-
-  return NULL_TREE;
+  if (!m_op)
+    return true;
+  return m_op->supports_bulk_merge_p ();
 }
 
 } // namespace ana
